# o-ffmpeg: video output via ffmpeg

this is a `cli` output module, don't use it in the gui! the gui may perform
frame drops, especially when the outputs need to be written out and are encoded
as we go.

an example command line would be
```
 vkdt-cli -g /path/to/mlv-sidecar.cfg --format o-ffmpeg --audio audio.raw
```
note that the sidecar here can be the one you've been using in the gui,
i.e. the autogenerated one if you point `vkdt` to the folder or file
will work. the `cli` will append the necessary processing chain to the graph.

we use plain `popen()` style communication with the ffmpeg binary (you'll need
to have it installed in your `PATH` for this to work).

this module only writes a `.mov` stream, the audio channels will need to be
combined manually, maybe like
```
 ffmpeg -i output.mov -f s16le -sample_rate 48000 -channels 2 -i audio.raw -c:v copy combined.mp4
```

one of the few ways of replaying a video with perceptual quantiser or hybrid log-gamma curves
seems to be something like
```
 ffplay test_0000.mov -vf zscale=transferin=arib-std-b67:transfer=bt709:rangein=tv:range=pc:primariesin=2020:primaries=709
```

## connectors

* `input` the sink to read the raw pixel data

## parameters

* `filename` the output filename to write the stream to
* `profile` the encoding quality preset
* `quality` affects the bitrate
* `colour` chroma subsampling: 422 or 4444, both 10 bits
